// Generated by dts-bundle v0.7.3

/**
  * @module dck-validators
  */

/**
    * Describes a validation result. Validation result
    * determines whether the validate data valid or empty.
    */
export interface IValidationResult {
        valid?: boolean;
        empty?: boolean;
}
/**
    * Any value will be valid result.
    * @param {string} value input string
    */
export function anything(value: string): Promise<{}>;
/**
    * Checks that input string contains email.
    * @param {string} value input string
    */
export function email(value: string, optional?: boolean): Promise<{}>;
/**
    * Password validation, the correct password should contain more than 6 letters.
    * @param {string} value input string
    */
export function password(value: string): Promise<{}>;
/**
    * Password confirmation validation, the confirm password should be the same as password.
    * @param {() => string} passwordExtractor password extractor
    */
export function passwordConfirmation(passwordExtractor: () => string): (value: string) => Promise<{}>;
/**
    * Validator for the required value, the result will be valid if the input string contains any value.
    * @param {string} value input string
    */
export function requiredValue(value: string): Promise<{}>;
/**
    * Date value validator, the result will be valid if the input string contains date.
    * @param {string} value input string
    */
export function date(value: string, optional?: boolean): Promise<{}>;
/**
    * Phone number validator, the result will be valid if the input string contains phone number.
    * @param {string} value input string
    */
export function phoneNumber(value: string, optional?: boolean): Promise<{}>;
/**
    * Gender validator, the result will be valid if the input string contains gender(MALE or FEMALE).
    * @param {string} value input string
    */
export function gender(value: string, optional?: boolean): Promise<{}>;
/**
    * Float validator, the result will be valid if the input string contains float value.
    * @param {string} value input string
    */
export function float(value: string, optional?: boolean): Promise<{}>;
/**
    * Non empty validator, the result will be valid if the input string contains non empty.
    * @param {string} value input string
    */
export function nonEmpty(value: string): Promise<{}>;
/**
    * Regex validator, the result will be valid if the input string match with regex.
    * @param {RegExp} regExp input regexp
    */
export function regexpValidator(regExp: RegExp): (value: string) => Promise<{}>;
/**
    * Server-side validation, input string will be checking on the server.
    * @param {() => Promise<any>} requestGenerator server request
    */
export function serverSideValidator(requestGenerator: () => Promise<any>): Promise<{}>;

